Index: CMakeLists.txt
===================================================================
--- CMakeLists.txt	(revision 310)
+++ CMakeLists.txt	(revision 313)
@@ -24,9 +24,8 @@
 SET(DEFAULT_CONF_PATH ${CMAKE_INSTALL_PREFIX}/etc/freeDiameter CACHE PATH "Default location of freeDiameter configuration files")
 
-SET(INSTALL_DOCUMENTATION_PATH 	${CMAKE_INSTALL_PREFIX}/doc/freeDiameter	CACHE PATH "Directory where the documentation is installed.")
-SET(INSTALL_HEADERS_PATH 	${CMAKE_INSTALL_PREFIX}/include/freeDiameter 	CACHE PATH "Directory where the headers are installed.")
-SET(INSTALL_EXTENSIONS_PATH 	${CMAKE_INSTALL_PREFIX}/lib/freeDiameter	CACHE PATH "Directory where the extensions are installed / searched.")
-SET(INSTALL_DAEMON_PATH 	${CMAKE_INSTALL_PREFIX}/bin 			CACHE PATH "Directory where the daemon binary is installed.")
-SET(INSTALL_LIBRARY_PATH 	${CMAKE_INSTALL_PREFIX}/lib 			CACHE PATH "Directory where the libfreeDiameter library is installed.")
+SET(INSTALL_HEADERS_SUFFIX 		include/freeDiameter 	CACHE PATH "Directory where the headers are installed (relative to CMAKE_INSTALL_PREFIX).")
+SET(INSTALL_EXTENSIONS_SUFFIX 		lib/freeDiameter	CACHE PATH "Directory where the extensions are installed / searched (relative to CMAKE_INSTALL_PREFIX).")
+SET(INSTALL_DAEMON_SUFFIX 		bin 			CACHE PATH "Directory where the daemon binary is installed (relative to CMAKE_INSTALL_PREFIX).")
+SET(INSTALL_LIBRARY_SUFFIX 		lib 			CACHE PATH "Directory where the libfreeDiameter library is installed (relative to CMAKE_INSTALL_PREFIX).")
 
 # All source code should be POSIX 200112L compatible, but some other extensions might be used, so:
@@ -59,86 +58,2 @@
 # Extensions (there is no point in freeDiameter without any extension)
 SUBDIRS(extensions)
-
-
-####
-## INSTALL section ##
-
-INSTALL(FILES README LICENSE doc/freediameter.conf.sample
-	DESTINATION ${INSTALL_DOCUMENTATION_PATH}
-	COMPONENT freeDiameter-daemon)
-
-
-
-####
-## Packaging section ##
-
-# Default: build a debian package
-SET(CPACK_GENERATOR DEB)
-
-# Parameters for the package
-SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
-SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "freeDiameter: a Diameter implementation (protocol for Authentication, Authorization and Accounting, evolution of RADIUS)")
-SET(CPACK_PACKAGE_VENDOR "This is open software")
-SET(CPACK_PACKAGE_VERSION_MAJOR "${FD_PROJECT_VERSION_MAJOR}")
-SET(CPACK_PACKAGE_VERSION_MINOR "${FD_PROJECT_VERSION_MINOR}")
-SET(CPACK_PACKAGE_VERSION_PATCH "${FD_PROJECT_VERSION_REV}")
-
-SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
-SET(CPACK_PACKAGE_CONTACT "Sebastien Decugis <sdecugis@nict.go.jp>")
-SET(CPACK_PACKAGE_INSTALL_DIRECTORY "CMake ${CMake_VERSION_MAJOR}.${CMake_VERSION_MINOR}")
-
-SET(CPACK_COMPONENTS_ALL 
-	freeDiameter-common 
-	freeDiameter-daemon 
-	freeDiameter-dictionary-RFC4005
-	freeDiameter-dictionary-RFC4072
-	freeDiameter-radius-gateway
-	freeDiameter-accounting-server
-	freeDiameter-dev
-	freeDiameter-debug-tools
-	)
-	
-# freeDiameter-common
-SET( CPACK_COMPONENT_FREEDIAMETER-COMMON_DISPLAY_NAME "freeDiameter library" )
-SET( CPACK_COMPONENT_FREEDIAMETER-COMMON_DESCRIPTION "The library needed by all freeDiameter components" )
-SET( CPACK_COMPONENT_FREEDIAMETER-COMMON_REQUIRED ON)
-
-# freeDiameter-daemon
-SET( CPACK_COMPONENT_FREEDIAMETER-DAEMON_DISPLAY_NAME "freeDiameter daemon binary" )
-SET( CPACK_COMPONENT_FREEDIAMETER-DAEMON_DESCRIPTION "The daemon providing Diameter Base Protocol support" )
-SET( CPACK_COMPONENT_FREEDIAMETER-DAEMON_DEPENDS freeDiameter-common)
-
-# freeDiameter-dictionary-RFC4005
-SET( CPACK_COMPONENT_FREEDIAMETER-DICTIONARY-RFC4005_DISPLAY_NAME "freeDiameter RFC4005 (NASREQ) dictionary" )
-SET( CPACK_COMPONENT_FREEDIAMETER-DAEMON_DESCRIPTION "An extension to the daemon's dictionary, providing commands and AVPs for NASREQ application" )
-SET( CPACK_COMPONENT_FREEDIAMETER-DAEMON_DEPENDS freeDiameter-daemon)
-
-# freeDiameter-dictionary-RFC4072
-SET( CPACK_COMPONENT_FREEDIAMETER-DICTIONARY-RFC4072_DISPLAY_NAME "freeDiameter RFC4072 (EAP) dictionary" )
-SET( CPACK_COMPONENT_FREEDIAMETER-DAEMON_DESCRIPTION "An extension to the daemon's dictionary, providing commands and AVPs for Diameter EAP application" )
-SET( CPACK_COMPONENT_FREEDIAMETER-DAEMON_DEPENDS freeDiameter-dictionary-RFC4005)
-
-# freeDiameter-radius-gateway
-SET( CPACK_COMPONENT_FREEDIAMETER-RADIUS-GATEWAY_DISPLAY_NAME "RADIUS/Diameter gateway extension for freeDiameter" )
-SET( CPACK_COMPONENT_FREEDIAMETER-RADIUS-GATEWAY_DESCRIPTION "This extension provides translation of RADIUS client messages to Diameter servers" )
-SET( CPACK_COMPONENT_FREEDIAMETER-RADIUS-GATEWAY_DEPENDS freeDiameter-dictionary-RFC4072)
-
-# freeDiameter-accounting-server
-SET( CPACK_COMPONENT_FREEDIAMETER-ACCOUNTING-SERVER_DISPLAY_NAME "Accounting server extension for freeDiameter" )
-SET( CPACK_COMPONENT_FREEDIAMETER-ACCOUNTING-SERVER_DESCRIPTION "This extension provides a simple configurable Diameter Base Accounting implementation" )
-SET( CPACK_COMPONENT_FREEDIAMETER-ACCOUNTING-SERVER_DEPENDS freeDiameter-daemon)
-
-# freeDiameter-dev
-SET( CPACK_COMPONENT_FREEDIAMETER-DEV_DISPLAY_NAME "freeDiameter headers" )
-SET( CPACK_COMPONENT_FREEDIAMETER-DEV_DESCRIPTION "Install the headers if you plan to develop new freeDiameter extensions" )
-SET( CPACK_COMPONENT_FREEDIAMETER-DEV_DEPENDS freeDiameter-common)
-
-# freeDiameter-debug-tools
-SET( CPACK_COMPONENT_FREEDIAMETER-DEBUG-TOOLS_DISPLAY_NAME "freeDiameter debug tools" )
-SET( CPACK_COMPONENT_FREEDIAMETER-DEBUG-TOOLS_DESCRIPTION "A set of tools meant for debugging freeDiameter" )
-SET( CPACK_COMPONENT_FREEDIAMETER-DEBUG-TOOLS_DEPENDS freeDiameter-daemon)
-
-# This is not working well at this time (may 2010), so leave it commented out for the moment.
-# INCLUDE(CPack)
-
-