Index: extensions/dict_dcca_3gpp/dict_dcca_3gpp.c
===================================================================
--- extensions/dict_dcca_3gpp/dict_dcca_3gpp.c	(revision 1470)
+++ extensions/dict_dcca_3gpp/dict_dcca_3gpp.c	(revision 1472)
@@ -1077,4 +1077,8 @@
 	/*==================================================================*/
 
+	/*==================================================================*/
+	/* 3GPP TS 29.128 Table 6.4.1-1: T6a/T6b specific Diameter AVPs     */
+	/*==================================================================*/
+
 	/* Communication-Failure-Information, Grouped, code 4300, section 6.4.4 */
 	{
@@ -1696,4 +1700,8 @@
 	/*==================================================================*/
 
+	/*==================================================================*/
+	/* 3GPP TS 29.173 Table 6.4.1/1: SLh specific Diameter AVPs         */
+	/*==================================================================*/
+
 	/* LMSI, OctetString, code 2400, section 6.4.2                      */
 	{
@@ -1853,5 +1861,8 @@
 
 	/*==================================================================*/
-	/* 3GPP 29.210-670 (6.7.0 2006-12-18)                               */
+	/* 3GPP TS 29.210 V6.7.0 (2006-12)                                  */
+	/* From 3GPP 29210-670.doc                                          */
+	/*                                                                  */
+	/* Replaced by 3GPP TS 29.212.                                      */
 	/*==================================================================*/
 
@@ -3336,4 +3347,8 @@
 	/*==================================================================*/
 
+	/*==================================================================*/
+	/* 3GPP TS 29.214 Table 5.3.0.1: Rx specific Diameter AVPs          */
+	/*==================================================================*/
+
 	/* Abort-Cause, Enumerated, code 500, section 5.3.1                 */
 	{
@@ -4895,4 +4910,8 @@
 	/* 3GPP TS 29.272 V15.10.0 (2019-12)                                */
 	/* From 3GPP 29272-fa0.docx                                         */
+	/*==================================================================*/
+
+	/*==================================================================*/
+	/* 3GPP TS 29.272 Table 7.3.1/1: S6a/S6d                            */
 	/*==================================================================*/
 
Index: extensions/dict_dcca_3gpp/dict_dcca_3gpp.csv
===================================================================
--- extensions/dict_dcca_3gpp/dict_dcca_3gpp.csv	(revision 1468)
+++ extensions/dict_dcca_3gpp/dict_dcca_3gpp.csv	(revision 1472)
@@ -1,4 +1,5 @@
-Attribute Name,Code,Section defined,Value Type,MUST,MAY,SHOULD NOT,MUST NOT,Encr
+Attribute Name,AVP Code,Section defined,Value Type,Must,May,Should not,Must not,May Encrypt
 @vendor,10415,,,,,,,
+,,,,,,,,
 @standard,3GPP TS 29.061,,,,,,,
 #=,,,,,,,,
@@ -81,8 +82,13 @@
 CN-IP-Multicast-Distribution,921,17.7.24,Enumerated,"M,V",P,,,
 MBMS-HC-Indicator,922,17.7.25,Enumerated,"M,V",P,,,
+,,,,,,,,
 @standard,3GPP TS 29.129,,,,,,,
 #=,,,,,,,,
 # 3GPP TS 29.128 V15.6.0 (2019-09),,,,,,,,
 # From 3GPP 29128-f60.docx,,,,,,,,
+#=,,,,,,,,
+#,,,,,,,,
+#=,,,,,,,,
+# 3GPP TS 29.128 Table 6.4.1-1: T6a/T6b specific Diameter AVPs,,,,,,,,
 #=,,,,,,,,
 #,,,,,,,,
@@ -114,4 +120,5 @@
 Idle-Status-Timestamp,4323,6.4.33,Time,V,,,M,No
 Active-Time,4324,6.4.34,Unsigned32,V,,,M,No
+,,,,,,,,
 @standard,3GPP TS 29.140,,,,,,,
 #=,,,,,,,,
@@ -144,8 +151,13 @@
 Status-Text,1118,6.3.21,UTF8String,"M,V",,,,N
 Routeing-Address-Resolution,1119,6.3.22,Enumerated,"M,V",,,,N
+,,,,,,,,
 @standard,3GPP TS 29.173,,,,,,,
 #=,,,,,,,,
 # 3GPP TS 29.173 V15.0.0 (2018-06),,,,,,,,
 # From 3GPP 29173-f00.doc,,,,,,,,
+#=,,,,,,,,
+#,,,,,,,,
+#=,,,,,,,,
+# 3GPP TS 29.173 Table 6.4.1/1: SLh specific Diameter AVPs,,,,,,,,
 #=,,,,,,,,
 #,,,,,,,,
@@ -162,10 +174,15 @@
 SGSN-Realm,2410,6.4.14,DiameterIdentity,V,,,M,N
 RIA-Flags,2411,6.4.15,Unsigned32,V,,,M,N
+,,,,,,,,
 @standard,3GPP TS 29.210,,,,,,,
 #=,,,,,,,,
-# 3GPP 29.210-670 (6.7.0 2006-12-18),,,,,,,,
+# 3GPP TS 29.210 V6.7.0 (2006-12),,,,,,,,
+# From 3GPP 29210-670.doc,,,,,,,,
+# ,,,,,,,,
+# Replaced by 3GPP TS 29.212.,,,,,,,,
 #=,,,,,,,,
 #,,,,,,,,
 PDP-Session-Operation,1015,5.2.21,Enumerated,"M,V",P,,,Y
+,,,,,,,,
 @standard,3GPP TS 29.212,,,,,,,
 #=,,,,,,,,
@@ -281,8 +298,13 @@
 CS-Service-Qos-Request-Identifier,2807,E.6.3.2,OctetString,"M,V",P,,,Y
 CS-Service-QoS-Request-Operation,2808,E.6.3.3,Enumerated,"M,V",P,,,Y
+,,,,,,,,
 @standard,3GPP TS 29.214,,,,,,,
 #=,,,,,,,,
 # 3GPP TS 29.214 V15.7.0 (2019-09),,,,,,,,
 # From 3GPP 29214-f70.doc,,,,,,,,
+#=,,,,,,,,
+#,,,,,,,,
+#=,,,,,,,,
+# 3GPP TS 29.214 Table 5.3.0.1: Rx specific Diameter AVPs,,,,,,,,
 #=,,,,,,,,
 #,,,,,,,,
@@ -353,4 +375,5 @@
 Sponsored-Connectivity-Data,530,5.3.27,Grouped,V,P,,M,Y
 Sponsoring-Action,542,5.3.40,Enumerated,V,P,,M,Y
+,,,,,,,,
 @standard,3GPP TS 29.229,,,,,,,
 #=,,,,,,,,
@@ -410,8 +433,13 @@
 Visited-Network-Identifier,600,6.3.1,OctetString,"M,V",,,,N
 Wildcarded-Public-Identity,634,6.3.35,UTF8String,V,,,M,N
+,,,,,,,,
 @standard,3GPP TS 29.272,,,,,,,
 #=,,,,,,,,
 # 3GPP TS 29.272 V15.10.0 (2019-12),,,,,,,,
 # From 3GPP 29272-fa0.docx,,,,,,,,
+#=,,,,,,,,
+#,,,,,,,,
+#=,,,,,,,,
+# 3GPP TS 29.272 Table 7.3.1/1: S6a/S6d, S7a/S7d and S13/S13' specific DiameterAVPs,,,,,,,,
 #=,,,,,,,,
 #,,,,,,,,
@@ -628,4 +656,5 @@
 eDRX-Related-RAT,1705,7.3.229,Grouped,V,,,M,N
 Interworking-5GS-Indicator,1706,7.3.231,Enumerated,V,,,M,N
+,,,,,,,,
 @standard,3GPP TS 29.329,,,,,,,
 #=,,,,,,,,
@@ -664,4 +693,5 @@
 Sequence-Number,716,6.3.25,Unsigned32,V,,,M,N
 UDR-Flags,719,6.3.28,Unsigned32,V,,,M,N
+,,,,,,,,
 @standard,3GPP TS 32.299,,,,,,,
 #=,,,,,,,,
@@ -942,4 +972,5 @@
 WLAN-Technology,893,,Unsigned32,"M,V",P,,,N
 WLAN-UE-Local-IPAddress,894,,Address,"M,V",P,,,N
+,,,,,,,,
 @standard,OMA DDS Charging Data,,,,,,,
 #=,,,,,,,,